// Ionic Starter App

// angular.module is a global place for creating, registering and retrieving Angular modules
// 'starter' is the name of this angular module example (also set in a <body> attribute in index.html)
// the 2nd parameter is an array of 'requires'
// 'starter.controllers' is found in controllers.js
angular.module('starter', ['ionic', 'steps', 'calories', 'sleep', 'heart', 'health', 'starter.controllers', 'starter.services', 'starter.directives', 'btconnect', 'btuserinfo', 'btalarm', 'btscreen', 'btcontroller_interface', 'ngCordova', 'LocalStorageModule', 'ngCordovaBluetoothLE', 'pascalprecht.translate','chart.js', 'angular-svg-round-progressbar', 'ngMessages', 'ngSanitize', 'ngMaterial', 'ngAria', 'ngAnimate', 'ngFitText', 'bthealthfit'])

.run(function($ionicPlatform, $rootScope) { 
  $ionicPlatform.ready(function() {
      var locale = window.navigator.userLanguage || window.navigator.language;
      moment.locale(locale); 
      
    // Hide the accessory bar by default (remove this to show the accessory bar above the keyboard
    // for form inputs)
    if (window.cordova && window.cordova.plugins.Keyboard) {
      cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
    }
      

   /*   
    if (window.StatusBar) {
        if (ionic.Platform.isAndroid()) {
           StatusBar.backgroundColorByHexString("#000000");
        } else {
            StatusBar.overlaysWebView(true);
            StatusBar.backgroundColorByHexString("#000000");
        }
      }
    */
      
    $rootScope.$on('$stateChangeSuccess', function (event, toState, toParams, fromState, fromParams) {
        if (toParams.categoryId) {
            $rootScope.headerColor = "header_"+toParams.categoryId;
        } else {
            $rootScope.headerColor = "header_leicke";
        }
    }); 
    
  });
}) 

.config(function ($ionicConfigProvider){
    $ionicConfigProvider.views.swipeBackEnabled(false);
})

.config(function ($translateProvider) {
    // NOTE: In order to get multilingual functions working modules need to be adjusted
    
    $translateProvider.useStaticFilesLoader({
        prefix: 'locale/',
        suffix: '.json'
    });

    $translateProvider
    .registerAvailableLanguageKeys(['en-GB', 'de-DE', 'it-IT', 'es-ES'], {
      'en_*': 'en-GB',
      'de_*': 'de-DE',
      'it_*': 'it-IT',
      'es_*': 'es-ES'
    })
    .fallbackLanguage('en-GB')
    .determinePreferredLanguage();
   
    $translateProvider.useSanitizeValueStrategy('sanitizeParameters');
})

.config(function (localStorageServiceProvider) {
  localStorageServiceProvider
    .setPrefix('leicke');
})

.config(function($stateProvider, $urlRouterProvider) {
  $stateProvider

  .state('app', {
    url: "/app",
    abstract: true,
    templateUrl: "templates/menu.html",
    controller: 'AppCtrl'
  })
  
  .state('app.main', {
    url: "/main",
    views: {
      'mainContent': {
        templateUrl: "templates/main.html",
          controller:'MainController'
      }
    }
  })

  .state('app.btconnect', {
    url: "/connect",
    views: {
      'mainContent': {
        templateUrl: "modules/BTConnect/btconnect.html",
        controller: 'BTConnectController'
      }
    }
  })
  
  .state('app.btuserinfo', {
    url: "/userinfo",
    views: {
      'mainContent': {
        templateUrl: "modules/BTUserInfo/btuserinfo.html",
        controller: 'BTUserInfoController'
      }
    }
  })
  
  
    .state('app.steps', {
        url:"/steps",
        views: {
            'mainContent': {
                templateUrl: "templates/steps.html",
                controller: "StepsController"
            }
        },
        params:{categoryId:'steps'}
    })
  
    .state('app.calories', {
        url:"/calories",
        views: {
            'mainContent': {
                templateUrl: "templates/calories.html",
                controller: "CaloriesController"
            }
        },
        params:{categoryId:'calories'}
    })
  
    .state('app.heart', {
        url:"/heart",
        views: {
            'mainContent': {
                templateUrl: "templates/heart.html",
                controller: "HeartController"
            }
        },
        params:{categoryId:'heart'}
    })
  
  
    .state('app.sleep', {
        url:"/sleep",
        views: {
            'mainContent': {
                templateUrl: "templates/sleep.html",
                controller: "SleepController"
            }
        },
        params:{categoryId:'sleep'}
    })
  
  .state('app.impressum', {
    url: "/impressum",
    views: {
      'mainContent': {
        templateUrl: "templates/impressum.html",
        controller: "ImpressumController"
      }
    }
  })
  
  .state('app.health', {
    url: "/health",
    views: {
      'mainContent': {
        templateUrl: "templates/health.html",
        controller: 'HealthCtrl'
      }
    }
  })

  $urlRouterProvider.otherwise('/app/main');
});
