angular.module('starter.directives', [])
.directive('openProgress', function () {
  return {
    restrict:'E',
    scope: {
        type: '@',
        current: '=',
        targetText: '=',
        target: '=',
        zoom: '=',
        fakeCurrent: '=',
        fakeTarget: '=',
        text: '@',
        imageZoom: '@',
        normalize: '=',
        extraClasses: '='
    },
    templateUrl: 'templates/dProgress.html',
    link: function (scope, $element, $attrs) {
        scope.bigValue = false;
        if (scope.zoom && scope.zoom < 1) {
            scope.bigValue = true;  
        }
      
        scope.realCurrent = angular.copy(scope.current);
        scope.$watch('[fakeCurrent,fakeTarget,current,target]', function() {
            scope.realCurrent = angular.copy(scope.current);
            if (scope.normalize) {
                if (scope.realCurrent / scope.target > 1) {
                    scope.displayCurrent = angular.copy(scope.current);
                    scope.realCurrent = scope.target - (scope.displayCurrent - scope.target);
                    if (scope.realCurrent < 0) scope.realCurrent = 0;
                } else {
                    scope.displayCurrent = angular.copy(scope.realCurrent);
                }
            } else {
                scope.displayCurrent = (scope.fakeCurrent || scope.fakeCurrent === 0) ? scope.fakeCurrent : scope.realCurrent;  
            }
            scope.displayTarget = scope.fakeTarget ? scope.fakeTarget : scope.target;
        }, true);
    }
  }
})
.directive('indicator', function() {
    return{
        restrict:'E',
        scope: {
            text: '@',
            show: '='
        },
        templateUrl: 'templates/dIndicator.html',
        link: function (scope, $element, $attrs) {
        }    
    }
});