angular.module('health', ['bthealthfit'])

.controller('HealthCtrl', function($scope, localStorageService, $translate, bthf_init) {
    $scope.isIOS = ionic.Platform.isIOS();
    if ($scope.isIOS) $translate('HEAL_TITLE_IOS').then(function (translation) {
        $scope.title = translation;
    });
    $scope.isAndroid = ionic.Platform.isAndroid();
    if ($scope.isAndroid) $translate('HEAL_TITLE_ANDROID').then(function (translation) {
        $scope.title = translation;
    });
    
    $scope.useHealth = localStorageService.get('useHealth') || {val:false};
    $scope.useSHealth = localStorageService.get('useSHealth') || {val:false};
    $scope.$watch('useHealth', function(newVal, oldVal){
        if (newVal != oldVal) {
            localStorageService.set('useHealth', $scope.useHealth);
            if (newVal.val) {
                // enabled
                bthf_init.init(); 
            } else {
                // disabled
                bthf_init.disable();
            }
        }
    }, true);
    
    $scope.$watch('useSHealth', function(newVal, oldVal){
        if (newVal != oldVal) {
            localStorageService.set('useSHealth', $scope.useHealth);
            if (newVal.val) {
                // enabled
                bthf_init.init_shealth(); 
            } else {
                // disabled
                bthf_init.disable_shealth();
            }
        }
    }, true);
    
    $scope.useSleep = localStorageService.get('useHealthSleep');
    $scope.$watch('useSleep', function(newVal, oldVal){
        localStorageService.set('useHealthSleep', $scope.useSleep);
        if (newVal != oldVal) {
            if (newVal.val) {
                // enabled
                bthf_init.enable_sleep = true; 
            } else {
                // disabled
                bthf_init.enable_sleep = false;
            }
        }
    }, true);
});