angular.module('heart', ['btdata', 'btcontroller_interface'])  // TODO: for mambo2_compress_data -> write btinterface_controller for this

.controller('HeartController', function($scope, localStorageService, $filter, $stateParams, $translate, dashboard, goals, heart_options, h_dayOverview, otherData,dayOverview_options, $ionicScrollDelegate) {
    $scope.reading = {};
    $scope.otherData = {
       steps:0,
       calories:0
    };
    $scope.heart = {};
    
    // active--------
    $scope.active = {};
    $scope.active['heart'] = 0;
    
    $scope.$on('$ionicView.enter', function() {
        getReading();
        
        var tmp = dashboard.values();
        if ($scope.active.heart == 0) $scope.active.heart = tmp.h;

        $scope.heart = {
            goal: goals.type("heart"),
            imagezoom: 90,
            aria: $translate.instant('TERM_HEART'),
            type: "heart"
        }
    });
    
    // when today is displayed and new data comes in
    $scope.$on('newData', function(event, args){
        if (args.type == 'heart') {
            if ($scope.h_selected == moment().format("YYYY-MM-DD")) {
                h_dayOverview.refresh();
                
                $scope.h_day_change(0);
            }
            fetchHeartEntries();
            getReading();
        } else if (args.type == 'daytime' && $scope.h_selected == moment().format("YYYY-MM-DD")) {
            otherData.refresh();
            $scope.h_day_change(0);
        }
    });

    $scope.hour_options = h_dayOverview.options();
    
    function getReading() {
            var val = localStorageService.get('heart_last_reading') || {reading:0,utc:parseInt(moment().format('X'))};
        
            $scope.reading['value'] = val.reading.toString();
            var tmpD = moment(val.utc*1000).add('second',1);
            $scope.reading['date'] = tmpD.format('DD.MM.YY HH:mm');
    }
    
    $scope.h_selected = h_dayOverview.current();
  
    $scope.overview = {};
    
    $scope.h_day_change = function (add) {
        $scope.limit = false;
        if (h_dayOverview.change(add)) {
            h_dayOverview.data().then(function(success){
                $scope.overview = success;
                $scope.h_selected = h_dayOverview.current();
                $scope.otherData = otherData.byDate($scope.h_selected);
                if ($scope.overview.atRestDay) 
                    $scope.percentage = Math.round($scope.overview.atRestDay.val / goals.type("heart") * 100);
                else if ($scope.overview.atRestAll)
                    $scope.percentage = Math.round($scope.overview.atRestAll.val / goals.type("heart") * 100);
                else $scope.percentage = 0;
                if ($scope.percentage > 100) $scope.percentage = 100 - ($scope.percentage - 100);
                if ($scope.percentage < 0) $scope.percentage = 0;
                $scope.heart['goal'] = goals.type("heart");
                
//                h_dayOverview.persist(success, $scope.h_selected).then(
//                    function(success) {
//                        $scope.heartEntries.push(success);
//                    }
//                );
            });
        } else {
            $scope.limit = true;
        }
    }
    $scope.h_day_change(0);
    
    /*
     *  VERLAUF
     */
    
    var fetchHeartEntries = function() {
        var heartEntries = localStorageService.get("parsed_heart_rate") || {};
        var tmpArray = [];
        for (key in heartEntries) {
            var tmp = heartEntries[key];
            tmp['date'] = moment(key);
            var atRest;
            if (tmp.day) atRest = tmp.day.atRest.val;
            if (!atRest && tmp.all) atRest = tmp.all.atRest.val;
            if (atRest) {
                tmp['atRest'] = atRest;
                tmpArray.push(tmp);
            }
        }
        $scope.heartEntries = tmpArray;
    }
    fetchHeartEntries();
    
    $scope.jumpTo = function (value) {
        $scope.bar_setActive(0);
        var target = new Date(value.date);
        var active = new Date($scope.h_selected);
        var diff = target - active;
        var days = diff/(1000 * 60 * 60 *24);
        $scope.h_day_change(days);
        $ionicScrollDelegate.scrollTop(true);
    }
    
    /* $scope.jumpTo = function (value) {
        $scope.bar_setActive(0);
        var target = moment(value.date);
        var active = moment($scope.selected_date);
        var diff = target.diff(active, 'days');
        $scope.hour_change(diff);
        $ionicScrollDelegate.scrollTop(true);
    }*/
    
    /*
     *  switch between day, week and month
     */
    
    $scope.bar_active = 0;
    $scope.bar_setActive = function(type) {
        $scope.bar_active = type;
        $scope.switchDataType (type); 
    };
    $scope.bar_isActive = function(type) {
        return type === $scope.bar_active;
    };
    
    $scope.switchDataType = function(type) {
        switch (type) {
            case 0:   
                break;
            case 1:
//                $scope.activeOverview = weeksSleep;
//                switchToOverview();
                break;
            case 2:
//                $scope.activeOverview = monthsSleep;
//                switchToOverview();
                break;
        }
    }
    
    $scope.controls = function(add) {
        switch ($scope.bar_active) {
            case 0:
                $scope.h_day_change(add);
                break;
            case 1:
            case 2:
//                $scope.activeOverview.change(add);
//                switchToOverview();
                break;
        }
    }
})

.factory("h_dayOverview", function(localStorageService, $q, heart_options, $filter, mambo2_compress_data, mambo2_heart_data, btinterface, $translate, $filter){
    var currentDate; // should be in format "YYYY-MM-dd"
    var currentYear = moment().year();
    var labelsInit = false;
    var options;
    
    function getOptions() {
        if (!options) options = heart_options.options();
        return options;
    }
    
    function getCurrent (asDate) {
        if (asDate) return moment(currentDate);
        else return currentDate;
    }
    
    function change (add) {
        if (!currentDate) currentDate = moment().format("YYYY-MM-DD");
        
        var tmpD = moment(currentDate).add(add, 'day');
        if (tmpD.isSameOrBefore(moment(), 'day')) {
            currentDate = tmpD.format("YYYY-MM-DD");
            return true;
        } else return false;
    }
    
    function data() {
        return $q(function(resolve) {
            // init options
            var _options = getOptions();
            
            // fetch heartData for this day
            var heartData = btinterface.byTagAndDate("heart",currentDate);// mambo2_heart_data.heartRateWithStats(currentDate);

            var tmpD_start = moment(currentDate).startOf('day');
            var date = tmpD_start.format('dd, DD.MM.YY');

            // result object -> identical structure to week/month
            var result = {
                labels:heartData.all.dates,
                data:[heartData.all.values],
                atRestNight:heartData.night.atRest,
                atRestDay:heartData.day.atRest,
                atRestAll:heartData.all.atRest,
                date:date,
                lowest:heartData.all.lowest,
                average:heartData.all.average,
                highest:heartData.all.highest,
                count:heartData.all.amountEntries,
                series:[$filter('titlize')($translate.instant('Puls'))],
                colors:['#e71d73'],
                options:_options
            }
            
            resolve(result);
        });
    }
    
    function persist(result, dateStr) {
        return $q(function(resolve, reject) {
            var error;
            if (dateStr == moment().format("YYYY-MM-DD")) error = "This is today. New data could still come in.";
        
            if (result.labels.length == 0) error = "No data to persist.";
            
            var heart_data_parsed = localStorageService.get("heart_data_parsed") || {};
            if (heart_data_parsed[dateStr]) error = "data already ";
            
            if (error) {
                reject(error);
                return;
            }
            
            var obj = {
                atRestNight:result.atRestNight,
                atRestDay:result.atRestDay,
                atRestAll:result.atRestAll,
                date:result.date,
                lowest:result.lowest,
                average:result.average,
                highest:result.highest,
                count:result._count,
            }

            heart_data_parsed[dateStr] = obj;
            localStorageService.set("heart_data_parsed", heart_data_parsed);
            resolve(obj);
        });
    }
    
    function refresh() {
        heartData = localStorageService.get("heart_data") || {};
    }
    
    return {
        data:data,
        current:getCurrent,
        change:change,
        persist:persist,
        refresh:refresh,
        options:getOptions
    }
})

.factory("heart_options", function($translate, $filter){
    return {
        options: function () {
            return {
                scales: {
                    yAxes: [{
                        ticks:{
                            beginAtZero:false,
                            //steps:14,
                            stepValue:10
                            //,max: 140
                        },
                        id: 'y-axis-1',
                        type: 'linear',
                        display: true,
                        position: 'left'
                    }]
                    ,xAxes: [{
                        type: 'time',
                        ticks:{
                            fontSize: 8,
                            autoSkip:true,
                            autoSkipPadding:10
                        },
                          time: {
                            format: "HH",
                            unit: 'hour',
                            unitStepSize: 2,
                            displayFormats: {
                              'minute': 'HH', 
                              'hour': 'HH', 
                            }
                          }
                    }]
                },
                spanGaps:false,
                showLines:true,
                tooltips: {
                    enabled:true,
                    callbacks:{
                        title: function(tooltipItem, data) {
                            return $translate("Datum")+": "+tooltipItem[0].xLabel.format('DD.MM.YYYY');
                        }
                    }
                },
                legend: {
                    display:false,
                    fullWidth:true,
                    labels:{
                        boxWidth:40
                    }
                },
                elements: {
                    line: {
                        tension: 0.1,                               // bezier 'curving' 0-straight 1-whohoo
                        fill:false                                  // remove the filling entirely
                    },
                    point: {
                        radius:0
                    }
                },
                responsive:true,                                   // fits it on the screen, yeah
                title: {
                    fontColor:'#878787',
                    fontSize:14,
                    display: true,
                    text: $filter('titlize')($translate.instant('Puls'))
                }
                ,zoom: {
                    enabled: true,
                    mode: 'x',
                },
                pan: {
                    enabled: true,
                    mode: 'x'
                }
                //,spanGaps:false,         
             }
        }
    }
})

.factory ('otherData', function (localStorageService) {
    var moving_data;
    
    return {
       refresh:function(){
           moving_data = localStorageService.get('moving_data') || {};
       },
       byDate:function(dateStr){
           var tmpD = moment(dateStr);
           if (!moving_data) moving_data = localStorageService.get('moving_data') || {};
           
           var result = {
               steps:0,
               calories:0,
               distance:0
           };
           
           if ((day = moving_data[tmpD.format('YYYY-MM-DD')])) {
               var d = day[day.length-1];
               result.steps = d.s;
               result.calories = d.c;
               result.distance = d.d
           }
           
           return result;
       }
   } 
});