"use strict";

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var Alarm = function () {
    function Alarm($interval) {
        var json = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

        _classCallCheck(this, Alarm);

        // json values
        this.alarm_on = json.alarm_on || false;
        this._hh = json.hh || 0;
        this._mm = json.mm || 0;
        this.repeat_array = json.repeat_array || [false, false, false, false, false, false, false]; // mo->su
        this.settings = {
            length: "05",
            strength: "0909",
            vibe: "02"
        };

        // init values
        if (json.moment) {
            this.time_moment = moment(json.moment);
        } else this.time('moment');
        this.repeat('days');
        this.repeat('boolean');
        this._deltatime = 0;
        this.display = false;
        this.inter = $interval;
    }

    _createClass(Alarm, [{
        key: "time",
        value: function time(type) {
            if (type === 'moment' && !moment) type = undefined;

            var result = void 0;
            switch (type) {
                case 'hex':
                    result = this.padStr(this._hh.toString(16)) + this.padStr(this._mm.toString(16));
                    break;
                case 'hh:mm':
                    result = this.padStr(this._hh) + ":" + this.padStr(this._mm);
                    break;
                case 'moment':
                    var min = this._mm + this._hh * 60;
                    var tmpD = moment().startOf('day').add(min, 'minute');
                    if (tmpD.diff(moment(), "minute") < 0) {
                        tmpD.add(1, 'd');
                    }
                    result = tmpD;
                    this.time_moment = result;
                    break;
                default:
                    result = {
                        hh: this._hh,
                        mm: this._mm
                    };
                    break;
            }
            return result;
        }
    }, {
        key: "repeat",
        value: function repeat(type) {
            var result = void 0;
            switch (type) {
                case 'boolean':
                    result = false;
                    angular.forEach(this.repeat_array, function (r) {
                        if (r) result = r;
                    });
                    this.repeat_boolean = result;
                    break;
                case 'days':
                    result = [];
                    var _i = 0;
                    while (_i < 7) {
                        var label = moment().startOf('week').add(_i, 'd').format('ddd');
                        result.push({
                            day: label,
                            value: this.repeat_array[_i]
                        });
                        _i++;
                    };
                    this.repeat_days = result;
                    break;
                case 'hex':
                    var tmp = this.repeat_array;

                    // get results into 8bit string
                    result = "";
                    for (var _i = 0; _i < this.repeat_array.length; _i++) {
                        if (this.repeat_array[_i]) result = "1" + result;else result = "0" + result;
                    }

                    // parse result to bin to hex string
                    result = parseInt(result, 2);
                    result = this.padStr(result.toString(16));
                    break;
                default:
                    result = this.repeat_array;
                    break;
            }
            return result;
        }
    }, {
        key: "toggleRepeat",
        value: function toggleRepeat(i) {
            this.repeat_array[i] = !this.repeat_array[i];
            this.repeat('days');
        }
    }, {
        key: "toJSON",
        value: function toJSON() {
            var result = {
                alarm_on: this.alarm_on,
                hh: this._hh,
                mm: this._mm,
                moment: this.time_moment,
                repeat_array: this.repeat_array,
                settings: this._settings
            };
            return result;
        }
    }, {
        key: "add",
        value: function add(val, type, deltatime) {
            if (deltatime) this._deltatime++;
            if (!deltatime || this._deltatime == deltatime) {
                if (type == "hh") {
                    this._hh += val;
                    if (this._hh >= 24) this._hh -= 24;
                    if (this._hh < 0) this._hh += 24;
                    this.time('moment');
                }
                if (type == "mm") {
                    this._mm += val;
                    if (this._mm >= 60) this._mm -= 60;
                    if (this._mm < 0) this._mm += 60;
                    this.time('moment');
                }
                this._deltatime = 0;
            }
        }
    }, {
        key: "padStr",
        value: function padStr(str) {
            str += "";
            while (str.length < 2) {
                str = "0" + str;
            }
            return str;
        }
    }, {
        key: "interval",
        value: function interval() {
            if (!this.repeat("boolean")) {
                var interval = this.inter;
                var me = this;
                var id = interval(function () {
                    var tmpD_goal = me.time_moment;
                    var tmpD_now = moment();
                    var seconds = tmpD_goal.diff(tmpD_now, 'seconds');
                    me.display = me.padStr(Math.floor(seconds / 3600)) + ":" + me.padStr(Math.floor(seconds % 3600 / 60)) + ":" + me.padStr(seconds % 60);
                    if (seconds <= 0) {
                        me.alarm_on = false;
                        me.display = false;
                        interval.cancel(id);
                    }
                }, 500);
            }
        }
    }]);

    return Alarm;
}();

angular.module('btalarm', ['ionic', 'ngCordova', 'LocalStorageModule', 'ngCordovaBluetoothLE', 'pascalprecht.translate', 'ngSanitize', 'ngMaterial', 'ngAria']).config(function ($stateProvider, $urlRouterProvider) {
    $stateProvider.state('app.btalarm', {
        url: "/alarm",
        views: {
            'mainContent': {
                templateUrl: "modules/BTAlarm/btalarm.html",
                controller: 'BTAlarmController'
            }
        }
    });
}).controller('BTAlarmController', function ($scope, localStorageService, $ionicPopup, btalarmService, mambo2_request, mambo2_request_parse, $rootScope, $interval, $translate, $filter) {
    $scope.Wecker = $filter('titlize')($translate.instant('Wecker'));

    function init_alarms() {
        var alarms = localStorageService.get('alarms');
        if (alarms && alarms.length > 0) {
            $scope.alarms = alarms.map(mapAlarm);
        } else $scope.alarms = [new Alarm($interval), new Alarm($interval), new Alarm($interval)];
    }

    var mapAlarm = function mapAlarm(tmp) {
        var a = new Alarm($interval, tmp);
        a.interval();
        return a;
    };

    $rootScope.$watch(function () {
        return mambo2_request_parse.data;
    }, function (newData, oldData) {
        if (newData != oldData && newData.type === "02") {
            newData = newData.data;
            var tmp_alarms = newData.alarms;
            if (tmp_alarms.length > 0) {
                var alarms = tmp_alarms.map(mapAlarm);
                for (var idx in tmp_alarms) {
                    if (tmp_alarms[idx].settings.length != "00") {
                        var a = new Alarm($interval, tmp_alarms[idx]);
                        if (!a.repeat_boolean) a.interval();
                        $scope.alarms[idx] = a;
                    }
                }
            }

            localStorageService.set('alarms', $scope.alarms.map(function (tmp) {
                return tmp.toJSON();
            }));
        }
    });

    $scope.$on('$ionicView.enter', function (event, data) {
        init_alarms();

        mambo2_request.send("02");
    });

    $scope.showDetails = function (idx) {
        $scope.alarm = angular.copy($scope.alarms[idx]);

        var myPopup = $ionicPopup.show({
            templateUrl: 'modules/BTAlarm/timePicker.html',
            title: $filter('titlize')($translate.instant('Wecker stellen')),
            scope: $scope,
            cssClass: 'alarm',
            buttons: [{ text: $translate.instant('abbrechen') }, {
                text: '<b>' + $translate.instant('jetzt stellen') + '</b>',
                type: 'button-positive',
                onTap: function onTap(e) {
                    if ($scope.alarm) {
                        $scope.alarm.alarm_on = true;
                        $scope.alarms[idx] = angular.copy($scope.alarm);
                        $scope.alarms[idx].interval();
                        $scope.alarm = undefined;
                        $scope.setAlarms();
                    }
                }
            }]
        });
    };

    $scope.setAlarms = function () {
        localStorageService.set('alarms', $scope.alarms.map(function (tmp) {
            return tmp.toJSON();
        }));
        btalarmService.setAlarms($scope.alarms);
    };
}).factory('btalarmService', function ($cordovaBluetoothLE, $rootScope, mambo2_message_sender, localStorageService) {
    var hexStringToBinary = function hexStringToBinary(hexString) {
        if (hexString == null || hexString == "") {
            return null;
        }
        hexString = hexString.toUpperCase();
        var length = hexString.length / 2;
        var hexChars = hexString.split('');
        var d = new Array(length);
        for (var i = 0; i < length; i++) {
            var pos = i * 2;
            d[i] = parseInt(charToByte(hexChars[pos]) << 4 | charToByte(hexChars[pos + 1]), 10) & 255;
        }
        return d;
    };

    var padStr = function padStr(str) {
        while (str.length < 2) {
            str = "0" + str;
        }
        return str;
    };

    return {
        setAlarms: function setAlarms(alarms) {
            var switchON = true; // TODO: Find out what this is for

            var cw = "69";
            var type = "01"; // alarm clock

            var alarmSwitch = switchON ? "01" : "00"; // turn on/off
            var reminderCount = padStr(alarms.length.toString(16)); // must be '03'

            var value;
            if (switchON) {
                var repeatVal = "";

                for (var i = 0; i < alarms.length; i++) {
                    var a = alarms[i];
                    var serial = padStr(i.toString(16));
                    var alarmOn = a.alarm_on ? "01" : "00";
                    var time = a.time('hex'); // time
                    var repetition = padStr(a.repeat('hex'));
                    var remVibe = a.settings.vibe; // 3bzzszses; TODO: let user decide
                    var remLength = a.settings.length; // 5s; TODO: let user decide
                    var remStrength = a.settings.strength; // max; changes don't do much -> 01 is silent

                    repeatVal += serial + alarmOn + time + repetition + remVibe + remLength + remStrength;
                }

                value = cw + type + alarmSwitch + reminderCount + repeatVal;
            } else {
                value = cw + type + alarmSwitch;
            }

            mambo2_message_sender.send('8000', value);
        }
    };
});