'use strict';

angular.module('btconnect', ['ionic', 'ngCordova', 'LocalStorageModule', 'ngCordovaBluetoothLE', 'pascalprecht.translate', 'ngSanitize', 'ngMaterial', 'ngAria', 'btdata', 'btmessage', 'btscreen']).run(function ($ionicPlatform, $state, localStorageService, $ionicHistory, $rootScope, $timeout) {
    $ionicPlatform.ready(function () {
        // check for favored bluetooth connection
        if (!localStorageService.get('BTDevice')) {
            // no favored bluetooth connection yet -> redirect
            $ionicHistory.nextViewOptions({
                disableBack: true
            });
            $state.go('app.btconnect');
        }
        $timeout(function () {
            $rootScope.$broadcast('btstart');
        });
    });
});

/*

Order of events / files

Initialization:
- btconnect.js -> broadcast('btstart');
- controller.js:init() <-> btInit.js;

Establish BT connection:
- <optional> controller.js:$scope.scanBT <-> scan.js;
- controller.js:$scope.connect() <-> connection.js;
- controller.js:$scope.connect() -> services.js;

Services:
- services.js -> messages.js -> login.js;
- services.js -> messages.js -> userinfo.js;
- services.js: message_receiver.js -> messages.js -> services.js (data here sent to BTData-module) -> messages.js -> message_sender.js;

Extra (used everywhere):
- utils.js;
- crc32.js;

*/