'use strict';

/*
 *  btpermissions.js
 *  (factory)mambo2_permissions: handle android runtime permissions for Android > 6.0.0
 */

angular.module('btconnect').factory('mambo2_permissions', function ($q, $ionicPlatform, $cordovaBluetoothLE, $cordovaDevice, bt_messenger, localStorageService, bt_sms_messenger) {

    function check_permission(permissions, permission, idx) {
        var p = permission[idx].value;
        var loc_perm = localStorageService.get('permissions') || {};
        if (!loc_perm[p] || !loc_perm[p].value && loc_perm[p].repeat) {
            permissions.requestPermission(permissions[p], function (status) {
                loc_perm[p] = {
                    value: status.hasPermission,
                    repeat: permission[idx].repeat
                };
                localStorageService.set('permissions', loc_perm);

                idx++;
                if (idx < permission.length) {
                    check_permission(permissions, permission, idx);
                }
            }, function (error) {
                console.error("Permission error -> " + p + ": " + JSON.stringify(error));
                idx++;
                if (idx < permission.length) {
                    check_permission(permissions, permission, idx);
                }
            });
        }
    }

    function init() {
        document.addEventListener("deviceready", function () {
            var permissions = cordova.plugins.permissions;

            var toCheck = [{ value: "ACCESS_COARSE_LOCATION", repeat: true }, { value: "READ_PHONE_STATE", repeat: false }, { value: "READ_CONTACTS", repeat: false }, { value: "RECEIVE_SMS", repeat: false }, { value: "READ_SMS", repeat: false }];

            var idx = 0;
            check_permission(permissions, toCheck, idx);
        });
    }

    return {
        initialize: init
    };
});