function hexStringToBinary(hexString) {
    if (hexString == null || hexString == "") {
        return null;
    }
    hexString = hexString.toUpperCase();
    var length = hexString.length / 2;
    var hexChars = hexString.split('');
    var d = new Array(length);
    for (var i = 0; i < length; i++) {
        var pos = i * 2;
        d[i] = parseInt(charToByte(hexChars[pos]) << 4 | charToByte(hexChars[pos + 1]), 10) & 255;
    }
    return d;
}

function charToByte(c) {
    return parseInt("0123456789ABCDEF".indexOf(c), 10) & 255;
}

function crc32(buffer) {
        var crc = 0;
        var crc_table = makeCRCTable();
        var size = buffer.length;
        for (i = 0; i < size; i++) {
            crc = (crc_table[(crc ^ buffer[i]) & 0xff] ^ crc >>> 8) >>> 0;
        }
        return crc;
    };

function makeCRCTable() {
        var c;
        var crcTable = new Uint32Array(256);
        for (var n = 0; n < 256; n++) {
            c = n;
            for (var k = 0; k < 8; k++) {
                c = c & 1 ? 0xEDB88320 ^ c >>> 1 : c >>> 1;
            }
            crcTable[n] = c;
        }
        return crcTable;
    };

function formatWithZero(content, targetLength) {
        var temp = "";
        for (var i = 0; i < targetLength - content.length; i++) {
            temp += "0";
        }
        temp += content;
        return temp;
    };

function getCRCResult(str) {
        str = str.replace(" ", "").toUpperCase();
        var binary = hexStringToBinary(str);
        var crcLong = crc32(binary);
        var crc = crcLong.toString(16);
        var x = 0;
        crc = formatWithZero(crc, 8);
        return crc;
    };

// TEST
//console.log(getCRCResult("C0070000D1060000D1000000B1060000"));
//adda841b