'use strict';

/*
 *  deviceinfo.js
 *  (factory)mambo2_deviceinfo: parse the device info received from device
 */

angular.module('btconnect').factory('mambo2_deviceinfo', function (localStorageService, mambo2_util) {
    var di = {
        parse: function parse(hexStr) {
            // 50d034ed7d530e34313742415430353930313034380100000000
            if (hexStr.substr(0, 2) != "50") mambo2_util.error("Wrong code word.", "mambo2_deviceinfo:parse()");
            var mac = hexStr.substring(2, 14); //d034ed7d530e
            var model = String.fromCharCode(parseInt(hexStr.substring(14, 24), 16).toString()); //3431374241
            var software_version = String.fromCharCode(parseInt(hexStr.substring(24, 32), 16).toString()); //54303539
            var hardware_version = String.fromCharCode(parseInt(hexStr.substring(32, 40), 16).toString()); //30313034
            var timezone = hexStr.substring(40, 42); // 38
            var heartRate = hexStr.substring(42, 44); // 01 -> on
            var heartRateOffStartTime = hexStr.substring(44, 48);
            var heartRateOffEndTime = hexStr.substring(48, 52);

            var dvi = {
                MAC: mac,
                model: model,
                software_version: software_version,
                hardware_version: hardware_version,
                timezone: timezone
            };
            localStorageService.set('device_info', dvi);
            console.log("Device information: " + JSON.stringify(dvi));
        }
    };
    return di;
});