angular.module('btcontroller_interface', ['btdata', 'LocalStorageModule'])

.factory('btinterface', function(localStorageService, mambo2_heart_data, mambo2_sleep_fetch, $q){
    var p_heartData, r_heartData;
    
    function byTagAndDate(tag, date) {
        var idx = moment(date).format('YYYY-MM-DD');
        var today = moment().format('YYYY-MM-DD')
        var result;
        
        switch (tag) {
            case 'heart': 
                var p_heartData = localStorageService.get('parsed_heart_rate') || {};
            
                // check if parsed data is available already
                if (!(tmp_res = p_heartData[idx])) {
                    // if not get raw data
                    tmp_res = mambo2_heart_data.heartRateWithStats(date);
                } else {
                    tmp_res.all.dates = tmp_res.all.dates.map(
                        function(d){
                            return moment(d)
                        }
                    );
                }
                result = tmp_res;
                break;
            case 'sleep':
                var r_sleepData = localStorageService.get('raw_sleep_data') || {};
                var native_sleepData = localStorageService.get('native_sleep_data') || {};

                if (r_sleepData[idx]) {
                    return mambo2_sleep_fetch.byDate(date, 300);
                } else if ((result = native_sleepData[idx])) {
                    if (result.length > 0) result[0]['date'] = idx;
                    return $q(function(resolve){
                        return resolve(result);
                    });
                } else {
                    return $q(function(resolve){
                        return resolve(false);
                    });
                }
                break;
        }
        
        return result;
    }
    
    function heartRateAtRest(date) {
        var d = moment(date).format('YYYY-MM-DD');
        return mambo2_heart_data.heartRateAtRest(d);
    }
    
    return {
        byTagAndDate:byTagAndDate,
        heartRateAtRest:heartRateAtRest
    }
})