angular.module('btdata.services')

.factory("btd_compress", function($filter, localStorageService, $rootScope, mambo2_compress_data, bthf_add, btsh_add) { 
    
    function moving_data(data) {
        // combination of legacy hour_data and daytime_data  
        var moving_data = localStorageService.get('moving_data') || {};
        
        
        // array to hold all new entries for healthkit
        var health_data = [];

        console.log("MOVINGDATA: "+JSON.stringify(data));
        angular.forEach(data.data, function(d) {
            // check for entry on that date
            var tmpD = moment(d.utc).format('YYYY-MM-DD');
            
            // prepare data
            var tmpM = moment(d.utc).diff(moment(d.utc).startOf('day'),'seconds');
            var _data = {}
            _data['time'] = tmpM;
            _data['s'] = d.steps;
            _data['c'] = parseFloat(d.calories);
            _data['d'] = d.distance;
            _data['ex_t'] = d.t_exercise;
            _data['ex_a'] = d.examount;

            // check and insert
            var entries = moving_data[tmpD] || [];
            var tmpIdx = entries.findIndex(function(entry){return entry.time==tmpM});
            if (tmpIdx < 0) {
                entries.push(_data);
                health_data.push({date:tmpD, data:_data});
            } else {
                console.warn("Moving data conflict:\nold:"+JSON.stringify(moving_data[tmpD][tmpIdx])+"\nnew:"+JSON.stringify(_data)+"\nDiscarded old and replaced with new data!");
                entries[tmpIdx] = _data;
            }
            
            // sort
            entries.sort(function(a,b){
                if (a.time > b.time) return 1;
                if (a.time < b.time) return -1;
                return 0; 
            });
            
            moving_data[tmpD] = entries;

            // voltage & status
            var status = {};
            status['battery_level'] = d.status.battery_level;
            status['voltage'] = d.voltage;
            status['sleep_status'] = d.status.sleep_status;
            status['intensity_level'] = d.status.intensity_level;
            localStorageService.set('last_status', status);
        });

        // save moving_data and broadcast event
        localStorageService.set('moving_data',moving_data);
        $rootScope.$broadcast("newData", {type:'moving'});
        
        // update health data
        bthf_add.addData('steps', health_data);
        bthf_add.addData('calories', health_data);
        bthf_add.addData('distance', health_data);
        btsh_add.addData('moving', health_data);
    }
  
    return {
        sleep_data: function (data, result) {
            mambo2_compress_data.compress(data, true, "sleep");
            $rootScope.$broadcast("newData", {type:'sleep'});
        },
        moving_data: moving_data
    }
    
});