'use strict';

angular.module('bthealthfit').factory('btsh_add', function (localStorageService, bthf_constants, bthf_init, $q) {
    var btsh = {
        addData: function addData(type, data) {
            if (bthf_init.shealth_initialized) switch (type) {
                case 'moving':
                    btsh.addMovingData(data);
                    break;
                case 'heart':
                    // bthf.heartRate(data);
                    break;
                case 'sleep':
                    // bthf.sleep(data.data, data.date);
                    break;
                default:
                    console.warn("btsh_add:addData() unknown type '" + type + "'!");
                    break;
            }
        },
        heartRate: function heartRate(data) {
            /*let params = {
                startDate: moment(data.date).add(data.offset_m-data.utc_offset, 'm').toDate(),
                endDate: moment(data.date).add(data.offset_m, 'm').toDate(),
                dataType: 'heart_rate',
                sourceName: bthf_constants.name,
                sourceBundleId: bthf_constants.bundle,
                value: data.value
            }
            navigator.health.store(params, function() {
                console.log("Heart rate was successfully stored.");
            }, function(s_error){
                console.error("HF store heart rate error: "+JSON.stringify(s_error));
            });*/
        },
        sleep: function sleep(data, date) {
            /*for (let i = 0; i < data.length; i++) {
                let _data = data[i];
                 // change format to compressed format
                angular.forEach(_data.sleepStatus, function(val){
                    let params = {
                        startDate:moment(val.startTime*1000).toDate(),
                        endDate:moment(val.startTime*1000).add(val.duration, 'm').toDate(),
                        dataType:'activity',
                        sourceName: bthf_constants.name,
                        sourceBundleId: bthf_constants.bundle
                    }
                     switch (val.status) {
                        case 1:
                            params['value'] = 'sleep.awake';
                            break;
                        case 2:
                            params['value'] = 'sleep.light';
                            break;
                        case 3:
                            params['value'] = 'sleep.deep';
                            break;
                        default:
                            console.error("Unknown sleep status!");
                            break;
                    }
                     navigator.health.query({
                        startDate:params.startDate,
                        endDate:params.endDate,
                        dataType:'activity'
                    }, function(success) {
                        // check if data is duplicate
                         let s = moment(params.startDate);
                        let e = moment(params.endDate);
                        let found = false;
                        for (let i = 0; i < success.length; i++) {
                            let tmp = success[i];
                            if (tmp.sourceBundleId == bthf_constants.sourceBundleId) {
                                if (moment(tmp.startDate).isSame(s) && moment(tmp.endDate).isSame(e)) {
                                    found = true;
                                    break;
                                }
                            }
                        }
                        
                        if (!found) {
                            console.log("HF store sleep log: "+JSON.stringify(params));
                            navigator.health.store(params, function() {
                                console.log("Sleep was successfully stored.");
                            }, function(s_error){
                                console.error("HF store sleep error: "+JSON.stringify(s_error));
                            });
                        }
                    }, function(q_error) {
                        console.log("HF query sleep error: "+JSON.stringify(q_error));
                        // data might just not be there. good - now save data
                        navigator.health.store(params, function() {
                            console.log("Sleep was successfully stored.");
                        }, function(s_error){
                            console.error("HF store sleep error: "+JSON.stringify(s_error));
                        });
                    });
                });
            }*/
        },
        addMovingData: function addMovingData(data) {
            var lastSHSent = localStorageService.get('lastSHSent_moving') || {};

            angular.forEach(data, function (d) {
                var _d = d.data;

                var data = {};
                if (lastSHSent.date != d.date) {
                    // no previous data sent for this day 
                    data['startDate'] = parseInt(moment(d.date).format('x'));
                    data['count'] = _d['s'];
                    data['distance'] = _d['d'];
                    data['calorie'] = _d['c'];
                } else {
                    // previously sent data on this day
                    data['startDate'] = parseInt(moment(lastSHSent.date).add(lastSHSent.time, 's').format('x'));
                    data['count'] = _d['s'] - lastSHSent.count;
                    data['distance'] = _d['d'] - lastSHSent.distance;
                    data['calorie'] = _d['c'] - lastSHSent.calorie;
                }
                data['endDate'] = parseInt(moment(d.date).add(_d.time, 's').format('x'));
                data['dataType'] = 'moving';
                data['offset'] = bthf_constants.timeOffset();

                if (data.count > 0 && cordova.plugins.shealth) {
                    lastSHSent = {
                        date: d.date,
                        time: _d.time,
                        count: _d['s'],
                        distance: _d['d'],
                        calorie: _d['c']
                    };
                    localStorageService.set('lastSHSent_moving', lastSHSent);

                    cordova.plugins.shealth.add(data, function () {
                        console.log("SH store log: Moving data was successfully stored.");
                    }, function (s_error) {
                        console.error("SH store moving data error: " + JSON.stringify(s_error));
                    });
                }
            });
        }
    };

    return btsh;
});