angular.module('btrequest', ['ionic', 'ngCordova', 'LocalStorageModule', 'ngCordovaBluetoothLE', 'pascalprecht.translate', 'ngSanitize', 'ngMaterial', 'ngAria'])

.config(function($stateProvider) {
  $stateProvider
  .state('app.btrequest', {
    url: "/request",
    views: {
      'mainContent': {
        templateUrl: "modules/BTRequest/btrequest.html",
        controller: 'BTRequestController'
      }
    }
  })
  
  .state('app.btrequest_details', {
    url: "/request/details",
    views: {
      'mainContent': {
        templateUrl: "modules/BTRequest/btrequest_details.html",
        controller: 'BTRequestDetailsController'
      }
    },
    params:{data:null}
  })
})

.controller('BTRequestController', function($scope, mambo2_request, mambo2_request_parse, $rootScope, $state){
    $scope.items = [
        {
            name:"nothing",
            value:"00"
        },{
            name:"User information",
            value:"01"
        },{
            name:"Alarm clock",
            value:"02"
        },{
            name:"Call reminder",
            value:"03"
        },{
            name:"Hear rate",
            value:"04"
        },{
            name:"Sedentary",
            value:"05"
        },{
            name:"Anti-lost",
            value:"06"
        }
    ];
    $scope.details = [];
    $scope.activeType = {
        value:"00"
    };
    $scope.showDetails = false;
    
    $scope.itemSelected = function(item) {
        $scope.activeType = item;
        mambo2_request.send(item.value);
    }
    
    $rootScope.$watch(function(){
        return mambo2_request_parse.data;
    }, function(newData,oldData){
        if (newData.type == $scope.activeType.value) {
            var tmpData = newData;
            tmpData['title'] = $scope.activeType.name; 
            $state.go('app.btrequest_details',{data:tmpData});
        }
    });
    
    
})

.controller('BTRequestDetailsController', function($scope, $stateParams) {
    $scope.data;
    $scope.$on('$ionicView.enter', function (event, data) {
        if (data.stateParams.data) {
            $scope.data = data.stateParams.data;
        }
    });
   
})