'use strict';

angular.module('btscreen', ['ionic', 'btconnect', 'ngCordova', 'LocalStorageModule', 'ngCordovaBluetoothLE', 'pascalprecht.translate', 'ngSanitize', 'ngMaterial', 'ngAria']).config(function ($stateProvider, $urlRouterProvider) {
    $stateProvider.state('app.btscreen', {
        url: "/screen",
        views: {
            'mainContent': {
                templateUrl: "modules/BTScreen/btscreen.html",
                controller: 'BTScreenController'
            }
        }
    });
}).controller('BTScreenController', function ($scope, $rootScope, localStorageService, $translate, mambo2_services, mambo2_screen) {
    $scope.screenSettings = {};

    $scope.$on('$ionicView.enter', function (event) {
        $scope.screenSettings = localStorageService.get("screen_settings");
        mambo2_services.pause().then(function (success) {
            console.log("UNSUB: " + success);
        });
    });

    $scope.$on('$ionicView.leave', function (event) {
        mambo2_services.resume();
    });

    $scope.shouldShowReorder = false;
    $scope.screens = [];

    $scope.toggleActive = function (item) {
        var count = 0;
        var _iteratorNormalCompletion = true;
        var _didIteratorError = false;
        var _iteratorError = undefined;

        try {
            for (var _iterator = $scope.screenSettings.screens[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
                var i = _step.value;

                if (i.active) count++;
            }
        } catch (err) {
            _didIteratorError = true;
            _iteratorError = err;
        } finally {
            try {
                if (!_iteratorNormalCompletion && _iterator.return) {
                    _iterator.return();
                }
            } finally {
                if (_didIteratorError) {
                    throw _iteratorError;
                }
            }
        }

        if (count <= 1) return;
        item.active = !item.active;
        mambo2_screen.saveScreens($scope.screenSettings.screens);
        localStorageService.set('screen_settings', $scope.screenSettings);
    };

    $scope.reorderScreens = function (item, from, to) {
        from--;
        to--;
        $scope.screenSettings.screens.splice(from, 1);
        $scope.screenSettings.screens.splice(to, 0, item);
        mambo2_screen.saveScreens($scope.screenSettings.screens);
    };

    $scope.toggleReorder = function () {
        $scope.shouldShowReorder = !$scope.shouldShowReorder;
    };

    $scope.toggleOrientation = function () {
        if ($scope.screenSettings.orientation == 'horizontal') {
            $scope.screenSettings.orientation = 'vertical';
            mambo2_screen.saveOrientation(false);
        } else {
            $scope.screenSettings.orientation = 'horizontal';
            mambo2_screen.saveOrientation(true);
        }
    };

    // language
    $scope.activeLanguage = $translate.use();
    $scope.changeLanguage = function (langKey) {
        $translate.use(langKey);
        moment.locale(langKey);
        $scope.activeLanguage = langKey;
        console.log("Lang: " + $translate.use());
    };
});