angular.module('btuserinfo', ['ionic', 'ngCordova', 'LocalStorageModule', 'ngCordovaBluetoothLE', 'pascalprecht.translate', 'ngSanitize', 'ngMaterial', 'ngAria', 'btrequest'])

.controller('BTUserInfoController', function($scope, localStorageService, mambo2_change_userinfo, mambo2_request, mambo2_request_parse, $rootScope){
    $scope.data = {
        height:localStorageService.get("userinfo_height") || "1,72",
        weight:localStorageService.get("userinfo_weight") || "60"
    }
    
    $scope.dataChanged = false;
    
    
    
    $scope.update = function() {
        if ($scope.dataChanged) {
            localStorageService.set("userinfo_height", $scope.data.height);
            localStorageService.set("userinfo_weight", $scope.data.weight);
            mambo2_change_userinfo.send()
        } else {
            console.log("NO CHANGES");
        }
    }
    
    // get device data
    $rootScope.$watch(function(){
        return mambo2_request_parse.data;
    }, function(newData,oldData){
        if (newData != oldData && newData.type === "01") {
            newData = newData.data;
            console.log("D_USERINFO: "+JSON.stringify(newData));
            $scope.data = {
                height:parseFloat(newData.height).toFixed(2),
                weight:parseFloat(newData.weight).toFixed(2)
            }
            
            $scope.$watch('data', function(newVal, oldVal){ 
                if (newVal != oldVal) {
                    $scope.dataChanged = true;   
                }
            }, true);
        }
    });
    
    $scope.$on('$ionicView.enter', function (event, data) {    
        mambo2_request.send("01");
    });
    
});