'use strict';

/*
 *  userinfo.js
 *  (factory)mambo2_userinfo: send the userinfo to device
 */

angular.module('btuserinfo').factory('mambo2_change_userinfo', function (localStorageService, mambo2_util, mambo2_message_sender) {

    // requires string separated by a dot. e.g.: "75.38"kg 
    var weightToHex = function weightToHex(kilo) {
        var idx = kilo.indexOf(".");
        var powerTen = 0;
        if (idx < 0) powerTen = "00";else {
            var tmp = kilo.length - (idx + 1);
            tmp = 256 - tmp;
            powerTen = tmp.toString(16);
        }

        var nums = parseInt(kilo.replace(".", ""), 10);
        var numsHex = nums.toString(16);
        numsHex = ("00000" + numsHex).slice(-6);+console.log("WEIGHT: " + kilo + " -> " + (powerTen + numsHex));
        return powerTen + numsHex;
    };

    var targetState = function targetState() {
        return "01";
    };

    var weekTarget = function weekTarget() {
        return "0000007d"; // 200 Schritte
    };

    var boolToHex = function boolToHex(boolVal) {
        return boolVal ? "01" : "00";
    };

    // assemble and send
    function send() {
        var pSerial = "8000";

        var cw = "68";
        var deleteData = boolToHex(false); // no

        // weight
        var tmpWeight, weight;
        if (tmpWeight = localStorageService.get('userinfo_weight')) {
            weight = weightToHex(tmpWeight);
        } else {
            localStorageService.set('userinfo_weight', "60");
            weight = weightToHex("60");
        }

        // height
        var tmpHeight, height;
        if (tmpHeight = localStorageService.get("userinfo_height")) {
            height = weightToHex(tmpHeight); // 'weightToHex' works for heights also
        } else {
            localStorageService.set('userinfo_height', "1.72");
            height = weightToHex("1.72"); // 'weightToHex' works for heights also
        }

        var ts = targetState();
        var wt = weekTarget();

        var value = cw + deleteData + weight + height + ts + wt;

        mambo2_message_sender.send(pSerial, value);
    };

    return {
        send: send
    };
});